(* $Id: proofs.sml,v 1.1 2000/10/17 22:27:18 abel Exp $ *)

signature PROOFS =
sig

  datatype Hyp = Hyp of Prop.Prop	(* H ::= A      *)

  datatype Assertion =			(* E ::=        *)
    Line of Prop.Prop			(*       A      *)
  | Frame of Hyp * Proof		(*     | [H; P] *)
  and Proof =				(* P ::=        *)
    Final of Assertion			(*     | E      *)
  | Step of Assertion * Proof		(*     | E; P   *)

end; (* signature PROOFS *)

structure Proofs :> PROOFS =
struct

  datatype Hyp = Hyp of Prop.Prop	(* H ::= A      *)

  datatype Assertion =			(* E ::=        *)
    Line of Prop.Prop			(*       A      *)
  | Frame of Hyp * Proof		(*     | [H; P] *)
  and Proof =				(* P ::=        *)
    Final of Assertion			(*     | E      *)
  | Step of Assertion * Proof		(*     | E; P   *)

end; (* structure Proofs *)
